package com.liang.dao;

import com.liang.entity.PrjCompletecompany;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 完成单位(PrjCompletecompany)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-10 11:21:40
 */
public interface PrjCompletecompanyDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjCompletecompany queryById(Integer id);

    /**
     * 通过XM查询单条数据
     *
     * @param xm
     * @return 实例对象
     */
    List<PrjCompletecompany> queryByXM(Integer xm);


    /**
     * 查询指定行数据
     *
     * @param prjCompletecompany 查询条件
     * @param pageable           分页对象
     * @return 对象列表
     */
    List<PrjCompletecompany> queryAllByLimit(PrjCompletecompany prjCompletecompany, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjCompletecompany 查询条件
     * @return 总行数
     */
    long count(PrjCompletecompany prjCompletecompany);

    /**
     * 新增数据
     *
     * @param prjCompletecompany 实例对象
     * @return 影响行数
     */
    int insert(PrjCompletecompany prjCompletecompany);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjCompletecompany> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjCompletecompany> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjCompletecompany> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjCompletecompany> entities);

    /**
     * 修改数据
     *
     * @param prjCompletecompany 实例对象
     * @return 影响行数
     */
    int update(PrjCompletecompany prjCompletecompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除项目完成单位
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 获取项目完成单位
     *
     * @param map
     * @return
     */
    List<PrjCompletecompany> getCompanyList(Map map);

    List<PrjCompletecompany> getCompanyListFy(Integer xm);
}

